<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;
var workListIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var workLists = getHistologyWorkLists();
	
	var workList = frm.workList;
	if (workLists != null && workLists.length > 0)
	{
		for (var i=0; i < workLists.length; i++)
		{
			var list = workLists[i];
			var name = list.name + ' (' + list.size + ')';
			var option = new Option(name, list.id);
			workList.options[workList.length] = option;
		}
		workListIsValid = true;
		Main.show('gocreate');
	}
	else
	{
		setInputStatus('workList', 'No Histology works lists available for processing.', 'invalid');
	}
}

function getHistologyWorkLists()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading histology work lists...');
		var url = 'Histology.servlet?ID=<%=ID%>&cmd=GetHistologyWorkLists';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.workLists;
}


function step1IsValid()
{
	return workListIsValid;
}

function goCreate()
{
	if (!step1IsValid()) return;
	
	var frm = document.forms['reggie'];
	frm.submit();
}

function createWorkList()
{
	var url = 'histology_work_list.jsp?ID=<%=ID%>';
	location.href = url;
}

</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create lab tracking protocol for FFPE/HE" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select or create histology work list</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Histology work list</td>
				<td class="input"><select style="width:90%" 
						name="workList" id="workList" 
						onchange="histologyOnChange()"></select>
				</td>
				<td class="status" id="workList.status"></td>
				<td class="help"><span id="workList.message" class="message" style="display: none;"></span>
					Select an existing histology work list or choose to create a new one.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt"></td>
				<td class="input">
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button image="new.png" title="Create new work list" onclick="createWorkList()" />
					</base:buttongroup>
				</td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>